"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Provider = exports.useReleaseSocket = exports.useAcquireSocket = void 0;

var _react = _interopRequireWildcard(require("react"));

var _registry = _interopRequireDefault(require("./registry"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const SocketScopeContext = (0, _react.createContext)();

const useAcquireSocket = () => {
  const {
    acquire
  } = (0, _react.useContext)(SocketScopeContext) || {};
  return acquire;
};

exports.useAcquireSocket = useAcquireSocket;

const useReleaseSocket = () => {
  const {
    release
  } = (0, _react.useContext)(SocketScopeContext) || {};
  return release;
};

exports.useReleaseSocket = useReleaseSocket;

const Provider = ({
  socketDelay,
  children
}) => {
  const ctx = (0, _registry.default)(socketDelay);
  return _react.default.createElement(SocketScopeContext.Provider, {
    value: ctx
  }, children);
};

exports.Provider = Provider;